TemplateTransformationRepository

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## uk.ac.ic.doc.automed
Class TemplateTransformationRepository

    java.lang.Object
      |
      +--uk.ac.ic.doc.automed.TemplateTransformationRepository

public class TemplateTransformationRepository
extends java.lang.Object

Manipulate the Template Transformation Repository, built template transformations.

Constructor Summary
`TemplateTransformationRepository()`

Method Summary
`static void` | `createArgument(int arg_id, int arg_pos, int arg_id_ref, int arg_pos_ref, java.lang.String value)` Adds a new argument to a sequence of arguments
`static int` | `createCompositeTransformation(java.lang.String name, java.lang.String description, boolean preserves_eq)` Adds a new composite transformation to the TTR.
`static void` | `createCompositeTransformationDefinition(int trans_id, int arg_pos, java.lang.String table_name, java.lang.String field_name, java.lang.String description, boolean isReturnedValue)` Adds a new argument to the composite transformation's definition of arguments.
`static void` | `createCompositeTransformationProgram(int trans_id, int pc, int st_id, int arg_id)` Adds a new statement to a composite transformation's program
`static void` | `createCompositeTransformationReturnedValuesDefinition(int trans_id, int arg_id)` Defines where the transformation's returned values are stored.
`static int` | `createFirstArgument(int arg_pos, int arg_id_ref, int arg_pos_ref, java.lang.String value)` Creates a new sequence of arguments and adds a new argument to the sequence
`static int[]` | `getArgumentsArgIdList()` Returns a list of identifiers of all the sequences of arguments
`static int` | `getArgumentsArgIdRef(int arg_id, int arg_pos)` Returns a particular argument's `arg_id_ref` field
`static int[]` | `getArgumentsArgIdRefList(int arg_id)` Returns a particular's sequence of arguments list of `arg_id_ref` fields.
`static int[]` | `getArgumentsArgPosList(int arg_id)` Returns a particular's sequence of arguments list of positions.
`static int` | `getArgumentsArgPosRef(int arg_id, int arg_pos)` Returns a particular argument's `arg_pos_ref` field
`static int[]` | `getArgumentsArgPosRefList(int arg_id)` Returns a particular's sequence of arguments list of `arg_pos_ref` fields.
`static java.lang.String` | `getArgumentsValue(int arg_id, int arg_pos)` Returns a particular argument's `value` field
`static java.lang.String[]` | `getArgumentsValueList(int arg_id)` Returns a particular's sequence of arguments list of values.
`static int` | `getCompositeTransformationByName(java.lang.String name)` Returns the ID (`trans_id`) of the composite transformation specified by name
`static int[]` | `getCompositeTransformationDefinitionArgPosList(int trans_id)` Returns a particular transformation's list of argument positions.
`static int[]` | `getCompositeTransformationDefinitionArgPosList(int trans_id, boolean isReturnedValue)` Returns a particular transformation's list of argument positions.
`static java.lang.String` | `getCompositeTransformationDefinitionDescription(int trans_id, int arg_pos)` Returns a particular transformation's argument definition (only the `description` field).
`static java.lang.String[]` | `getCompositeTransformationDefinitionDescriptionList(int trans_id)` Returns a particular transformation's list of argument definitions (only the `description` field).
`static java.lang.String[]` | `getCompositeTransformationDefinitionDescriptionList(int trans_id, boolean isReturnedValue)` Returns a particular transformation's list of argument definitions (only the `description` field).
`static java.lang.String` | `getCompositeTransformationDefinitionFieldName(int trans_id, int arg_pos)` Returns a particular transformation's argument definition (only the `field_name` field).
`static java.lang.String[]` | `getCompositeTransformationDefinitionFieldNameList(int trans_id)` Returns a particular transformation's list of argument definitions (only the `field_name` field).
`static java.lang.String[]` | `getCompositeTransformationDefinitionFieldNameList(int trans_id, boolean isReturnedValue)` Returns a particular transformation's list of argument definitions (only the `field_name` field).
`static boolean` | `getCompositeTransformationDefinitionIsReturnedValue(int trans_id, int arg_pos)` Returns whether a particular transformation's argument stores a returned value after the transformation's invocation, or not.
`static boolean[]` | `getCompositeTransformationDefinitionIsReturnedValueList(int trans_id)` Returns a particular transformation's list of argument types (if they store a returned value or not).
`static java.lang.String` | `getCompositeTransformationDefinitionTableName(int trans_id, int arg_pos)` Returns a particular transformation's argument definition (only the `table_name` field).
`static java.lang.String[]` | `getCompositeTransformationDefinitionTableNameList(int trans_id)` Returns a particular transformation's list of argument definitions (only the `table_name` field).
`static java.lang.String[]` | `getCompositeTransformationDefinitionTableNameList(int trans_id, boolean isReturnedValue)` Returns a particular transformation's list of argument definitions (only the `table_name` field).
`static java.lang.String` | `getCompositeTransformationDescription(int trans_id)` Returns the description of the composite transformation specified by `trans_id`
`static java.lang.String` | `getCompositeTransformationName(int trans_id)` Returns the name of the composite transformation specified by `trans_id`
`static boolean` | `getCompositeTransformationPreservesEquivalence(int trans_id)` Returns whether the composite transformation specified by `trans_id` preserves schema equivalence.
`static int` | `getCompositeTransformationProgramArgId(int trans_id, int pc)` Returns the sequence of arguments ID that is going to be used at the specified pc of a transformation's template program.
`static int[]` | `getCompositeTransformationProgramArgIdList(int trans_id)` Returns a list of sequence of arguments identifiers of a particular composite transformation's template program, ie the sequences of arguments that are going to be used at each program counter.
`static int[]` | `getCompositeTransformationProgramPcList(int trans_id)` Returns a list of program counters of a particular composite transformation's template program.
`static int` | `getCompositeTransformationProgramStId(int trans_id, int pc)` Returns the statement ID of the statement that is going to be executed at the specified pc of a transformation's template program.
`static int[]` | `getCompositeTransformationProgramStIdList(int trans_id)` Returns a list of statement identifiers of a particular composite transformation's template program, ie the statements that are going to be executed at each program counter.
`static int` | `getCompositeTransformationReturnedValuesDefinitionArgId(int trans_id)` Returns the sequence of arguments ID that defines the returned values of the transformation
`static java.lang.String[]` | `getCompositeTransformationsDescriptionList()` Returns the descriptions of all the composite transformations found in the TTR
`static java.lang.String[]` | `getCompositeTransformationsDescriptionList(boolean preserves_eq)` Returns the descriptions of all the composite transformations found in the TTR that preserve schema equivalence
`static java.lang.String[]` | `getCompositeTransformationsNameList()` Returns the names of all the composite transformations found in the TTR
`static java.lang.String[]` | `getCompositeTransformationsNameList(boolean preserves_eq)` Returns the names of all the composite transformations found in the TTR that preserve schema equivalence
`static boolean[]` | `getCompositeTransformationsPreservesEquivalenceList()` Returns the `preserves_equivalence` field of all the composite transformations found in the TTR
`static int[]` | `getCompositeTransformationsTransIdList()` Returns the IDs of all the composite transformations found in the TTR
`static int[]` | `getCompositeTransformationsTransIdList(boolean preserves_eq)` Returns the IDs of all the composite transformations found in the TTR that preserve schema equivalence
`static java.lang.String` | `getDataSourceName()` Returns the name of the repository in the local database.
`static boolean` | `isValidTransId(int trans_id)` This method determines if a composite transformation with the specified `trans_id` exists in the TTR.
`static void` | `main(java.lang.String[] args)`
`static void` | `removeArgument(int arg_id, int arg_pos)` Removes a particular position from a sequence of arguments
`static void` | `removeArguments(int arg_id)` Removes a particular sequence of arguments
`static void` | `removeCompositeTransformation(int trans_id)` Removes a composite transformation from the TTR `comp_transformations` table
`static void` | `removeCompositeTransformationDefinition(int trans_id)` Removes all arguments definitions of a particular composite transformation
`static void` | `removeCompositeTransformationDefinition(int trans_id, int arg_pos)` Removes a particular position of a transformation's sequence of arguments
`static void` | `removeCompositeTransformationProgram(int trans_id)` Removes a particular template transformation's program
`static void` | `removeCompositeTransformationProgram(int trans_id, int pc)` Removes a particular program counter of a transformation's template program
`static void` | `removeCompositeTransformationReturnedValuesArgumentDefinition(int trans_id)` Removes a composite transformation returned values definition
`static void` | `setArgumentsArgIdRef(int arg_id, int arg_pos, int arg_id_ref)` Sets an argument's `arg_id_ref` field
`static void` | `setArgumentsArgPosRef(int arg_id, int arg_pos, int arg_pos_ref)` Sets an argument's `arg_pos_ref` field
`static void` | `setArgumentsValue(int arg_id, int arg_pos, java.lang.String value)` Sets an argument's `value` field
`static void` | `setCompositeTransformationDefinitionDescription(int trans_id, int arg_pos, java.lang.String description)` Sets a particular transformation's argument definition (the `description` field).
`static void` | `setCompositeTransformationDefinitionFieldName(int trans_id, int arg_pos, java.lang.String field_name)` Sets a particular transformation's argument definition (the `field_name` field).
`static void` | `setCompositeTransformationDefinitionIsReturnedValue(int trans_id, int arg_pos, boolean isReturnedValue)` Sets a particular transformation's argument type.
`static void` | `setCompositeTransformationDefinitionTableName(int trans_id, int arg_pos, java.lang.String table_name)` Sets a particular transformation's argument definition (the `table_name` field).
`static void` | `setCompositeTransformationDescription(int trans_id, java.lang.String description)` Sets the description of the composite transformation specified by `trans_id`
`static void` | `setCompositeTransformationName(int trans_id, java.lang.String name)` Sets the name of the composite transformation specified by `trans_id`
`static void` | `setCompositeTransformationPreservesEquivalence(int trans_id, boolean preserves_eq)` Sets the `preserves equivalence` field of the composite transformation specified by `trans_id`
`static void` | `setCompositeTransformationProgramArgId(int trans_id, int pc, int arg_id)` Sets the sequence of arguments ID in a specific program counter in the composite transformation's template program
`static void` | `setCompositeTransformationProgramStId(int trans_id, int pc, int st_id)` Sets the statement identifier in a specific program counter in the specified composite transformation's template program
`static void` | `setCompositeTransformationReturnedValuesDefinitionArgId(int trans_id, int arg_id)` Sets the sequence of arguments ID that defines the transformation's returned values.
`static void` | `setDataSourceName(java.lang.String str)` Sets the name of the repository in the local database.

Methods inherited from class java.lang.Object
`clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Constructor Detail

### TemplateTransformationRepository

    public TemplateTransformationRepository()

Method Detail

### createCompositeTransformation

    public static int createCompositeTransformation(java.lang.String name,
                                                    java.lang.String description,
                                                    boolean preserves_eq)
                                             throws TemplateTransformationRepositoryException,
                                                    RepositoryAccessException

  Adds a new composite transformation to the TTR. Composite transformation names are assumed to be unique. The creation of a composite transformation whose name already exists in the TTSR is rejected.
  Returns an integer that specifies the ID assigned to the new composite transformation.

  Parameters:
    `name` - name of transformation
    `description` - description of transformation
    `preserves_eq` - whether the new composite transformation preserves schema equivalence or not
  Returns:
    the composite transformation ID of the added transformation
  Throws:
    `TemplateTransformationRepositoryException` - if the specified name is `null`, or if a composite transformation with the same name already exists in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationByName

    public static int getCompositeTransformationByName(java.lang.String name)
                                                throws TemplateTransformationRepositoryException,
                                                       RepositoryAccessException

  Returns the ID (`trans_id`) of the composite transformation specified by name

  Parameters:
    `name` - name of the transformation
  Returns:
    ID of composite transformation
  Throws:
    `TemplateTransformationRepositoryException` - if the argument is `null`, or if no record of a transformation with the specific name exists in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationName

    public static java.lang.String getCompositeTransformationName(int trans_id)
                                                           throws TemplateTransformationRepositoryException,
                                                                  RepositoryAccessException

  Returns the name of the composite transformation specified by `trans_id`

  Parameters:
    `trans_id` - ID of the transformation
  Returns:
    the name of the transformation specified by `trans_id`
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR.
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDescription

    public static java.lang.String getCompositeTransformationDescription(int trans_id)
                                                                  throws TemplateTransformationRepositoryException,
                                                                         RepositoryAccessException

  Returns the description of the composite transformation specified by `trans_id`

  Parameters:
    `trans_id` - ID of the transformation
  Returns:
    the description of the transformation specified by `trans_id`
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR.
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationPreservesEquivalence

    public static boolean getCompositeTransformationPreservesEquivalence(int trans_id)
                                                                  throws TemplateTransformationRepositoryException,
                                                                         RepositoryAccessException

  Returns whether the composite transformation specified by `trans_id` preserves schema equivalence.

  Parameters:
    `trans_id` - ID of the transformation
  Returns:
    whether the transformation specified by `trans_id` preserves schema equivalence
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR.
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationsTransIdList

    public static int[] getCompositeTransformationsTransIdList()
                                                        throws RepositoryAccessException

  Returns the IDs of all the composite transformations found in the TTR

  Returns:
    a list of all transformation identifiers found in the TTR. Returns `null` if no records of composite transformations is found in the TTR.
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationsNameList

    public static java.lang.String[] getCompositeTransformationsNameList()
                                                                  throws RepositoryAccessException

  Returns the names of all the composite transformations found in the TTR

  Returns:
    a list of all transformation names found in the TTR. Returns `null` if no records of composite transformations is found in the TTR.
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationsDescriptionList

    public static java.lang.String[] getCompositeTransformationsDescriptionList()
                                                                         throws RepositoryAccessException

  Returns the descriptions of all the composite transformations found in the TTR

  Returns:
    a list of all transformation descriptions found in the TTR. Returns `null` if no records of composite transformations is found in the TTR.
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationsPreservesEquivalenceList

    public static boolean[] getCompositeTransformationsPreservesEquivalenceList()
                                                                         throws RepositoryAccessException

  Returns the `preserves_equivalence` field of all the composite transformations found in the TTR

  Returns:
    a list of all transformation `preserves_equivalence` fields found in the TTR. Returns `null` if no records of composite transformations is found in the TTR.
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationsTransIdList

    public static int[] getCompositeTransformationsTransIdList(boolean preserves_eq)
                                                        throws RepositoryAccessException

  Returns the IDs of all the composite transformations found in the TTR that preserve schema equivalence

  Returns:
    a list of all transformation IDs found in the TTR that preserve schema equivalence. Returns `null` if no records of composite transformations is found in the TTR that preserve schema equivalence.
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationsNameList

    public static java.lang.String[] getCompositeTransformationsNameList(boolean preserves_eq)
                                                                  throws RepositoryAccessException

  Returns the names of all the composite transformations found in the TTR that preserve schema equivalence

  Returns:
    a list of all transformation names found in the TTR that preserve schema equivalence. Returns `null` if no records of composite transformations is found in the TTR that preserve schema equivalence.
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationsDescriptionList

    public static java.lang.String[] getCompositeTransformationsDescriptionList(boolean preserves_eq)
                                                                         throws RepositoryAccessException

  Returns the descriptions of all the composite transformations found in the TTR that preserve schema equivalence

  Returns:
    a list of all transformation descriptions found in the TTR that preserve schema equivalence. Returns `null` if no records of composite transformations is found in the TTR that preserve schema equivalence.
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### setCompositeTransformationName

    public static void setCompositeTransformationName(int trans_id,
                                                      java.lang.String name)
                                               throws TemplateTransformationRepositoryException,
                                                      RepositoryAccessException

  Sets the name of the composite transformation specified by `trans_id`

  Parameters:
    `trans_id` - ID of the transformation
    `name` - new name of the transformation
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR, or if there is already a transformation with the specified name in the TTR, or if the specified name is `null`.
    `RepositoryAccessException` - if the repository cannot be accessed

### setCompositeTransformationDescription

    public static void setCompositeTransformationDescription(int trans_id,
                                                             java.lang.String description)
                                                      throws TemplateTransformationRepositoryException,
                                                             RepositoryAccessException

  Sets the description of the composite transformation specified by `trans_id`

  Parameters:
    `trans_id` - ID of the transformation
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR , or if the specified name is `null`.
    `RepositoryAccessException` - if the repository cannot be accessed

### setCompositeTransformationPreservesEquivalence

    public static void setCompositeTransformationPreservesEquivalence(int trans_id,
                                                                      boolean preserves_eq)
                                                               throws TemplateTransformationRepositoryException,
                                                                      RepositoryAccessException

  Sets the `preserves equivalence` field of the composite transformation specified by `trans_id`

  Parameters:
    `trans_id` - ID of the transformation
    `preserves_eq` - whether the transformation preserves schema equivalence
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### removeCompositeTransformation

    public static void removeCompositeTransformation(int trans_id)
                                              throws TemplateTransformationRepositoryException,
                                                     RepositoryAccessException

  Removes a composite transformation from the TTR `comp_transformations` table

  Parameters:
    `trans_id` - ID of the transformation
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` exists, or if there is a dependency conflict (records of this transformation exist in the `comp_transformation_definition` or `comp_trnasformation_program` tables)
    `RepositoryAccessException` - if the repository cannot be accessed

### isValidTransId

    public static boolean isValidTransId(int trans_id)
                                  throws RepositoryAccessException

  This method determines if a composite transformation with the specified `trans_id` exists in the TTR.

  Returns:
    `true` if a record of a transformation with the specified `trans_id` exists in the `comp_transformations` table, or `false` otherwise.
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### createCompositeTransformationDefinition

    public static void createCompositeTransformationDefinition(int trans_id,
                                                               int arg_pos,
                                                               java.lang.String table_name,
                                                               java.lang.String field_name,
                                                               java.lang.String description,
                                                               boolean isReturnedValue)
                                                        throws TemplateTransformationRepositoryException,
                                                               RepositoryAccessException

  Adds a new argument to the composite transformation's definition of arguments.

  Parameters:
    `trans_id` - ID of transformation
    `arg_pos` - position of argument in the transformation's sequence of arguments
    `table_name` - and
    `field_name` - define the values of this argument, i.e. from which table and field this argument gets its values.
    `description` - explanation of what this argument stands for
    `isReturnedValue` - true if this argument stores a transformation's returned value after invocation, false otherwise
  Throws:
    `TemplateTransformationRepositoryException` - if the arguments are invalid ( `trans_id` or `arg_pos` is less/equal to zero, or if either `table_name`, `field_name` is `null` and `description` is also `null`), or if no record for the specified `trans_id` is found in the TTR, or if a record already exists with the specified `trans_id` and `arg_pos`.
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionArgPosList

    public static int[] getCompositeTransformationDefinitionArgPosList(int trans_id)
                                                                throws TemplateTransformationRepositoryException,
                                                                       RepositoryAccessException

  Returns a particular transformation's list of argument positions. Returns `null` if no argument definitions exists for the specific transformation.

  Parameters:
    `trans_id` - ID of transformation
  Returns:
    a list of argument positions in a transformation's definition
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionArgPosList

    public static int[] getCompositeTransformationDefinitionArgPosList(int trans_id,
                                                                       boolean isReturnedValue)
                                                                throws TemplateTransformationRepositoryException,
                                                                       RepositoryAccessException

  Returns a particular transformation's list of argument positions. Returns `null` if no argument definitions exists for the specific transformation.

  Parameters:
    `trans_id` - ID of transformation
    `isReturnedValue` - true if the argument positions store the transformation's returned values, false otherwise
  Returns:
    a list of the argument positions that store the transformation's returned values if isReturnedValue is true, or a list of the argument posisions that store the transformation's invoked arguments if isReturnedValue is false
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionTableNameList

    public static java.lang.String[] getCompositeTransformationDefinitionTableNameList(int trans_id)
                                                                                throws TemplateTransformationRepositoryException,
                                                                                       RepositoryAccessException

  Returns a particular transformation's list of argument definitions (only the `table_name` field). Returns `null` if no argument definitions exists for the specific transformation.

  Parameters:
    `trans_id` - ID of transformation
  Returns:
    a list of argument definitions(`table_name`)
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionTableNameList

    public static java.lang.String[] getCompositeTransformationDefinitionTableNameList(int trans_id,
                                                                                       boolean isReturnedValue)
                                                                                throws TemplateTransformationRepositoryException,
                                                                                       RepositoryAccessException

  Returns a particular transformation's list of argument definitions (only the `table_name` field). Returns `null` if no argument definitions exists for the specific transformation.

  Parameters:
    `trans_id` - ID of transformation
    `isReturnedValue` - true if the arguments store the transformation's returned values, false otherwise
  Returns:
    a list of the argument definitions(`table_name`)) for the arguments that store the transformation's returned values if isReturnedValue is true, or a list of the argument definitions for the arguments that store the transformation's invoked arguments if isReturnedValue is false
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionFieldNameList

    public static java.lang.String[] getCompositeTransformationDefinitionFieldNameList(int trans_id)
                                                                                throws TemplateTransformationRepositoryException,
                                                                                       RepositoryAccessException

  Returns a particular transformation's list of argument definitions (only the `field_name` field). Returns `null` if no argument definitions exists for the specific transformation.

  Parameters:
    `trans_id` - ID of transformation
  Returns:
    a list of argument definitions(`field_name`)
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionFieldNameList

    public static java.lang.String[] getCompositeTransformationDefinitionFieldNameList(int trans_id,
                                                                                       boolean isReturnedValue)
                                                                                throws TemplateTransformationRepositoryException,
                                                                                       RepositoryAccessException

  Returns a particular transformation's list of argument definitions (only the `field_name` field). Returns `null` if no argument definitions exists for the specific transformation.

  Parameters:
    `trans_id` - ID of transformation
    `isReturnedValue` - true if the arguments store the transformation's returned values, false otherwise
  Returns:
    a list of the argument definitions(`field_name`)) for the arguments that store the transformation's returned values if isReturnedValue is true, or a list of the argument definitions for the arguments that store the transformation's invoked arguments if isReturnedValue is false
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionDescriptionList

    public static java.lang.String[] getCompositeTransformationDefinitionDescriptionList(int trans_id)
                                                                                  throws TemplateTransformationRepositoryException,
                                                                                         RepositoryAccessException

  Returns a particular transformation's list of argument definitions (only the `description` field). Returns `null` if no argument definitions exists for the specific transformation.

  Parameters:
    `trans_id` - ID of transformation
  Returns:
    a list of argument definitions(`description`)
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionDescriptionList

    public static java.lang.String[] getCompositeTransformationDefinitionDescriptionList(int trans_id,
                                                                                         boolean isReturnedValue)
                                                                                  throws TemplateTransformationRepositoryException,
                                                                                         RepositoryAccessException

  Returns a particular transformation's list of argument definitions (only the `description` field). Returns `null` if no argument definitions exists for the specific transformation.

  Parameters:
    `trans_id` - ID of transformation
    `isReturnedValue` - true if the arguments store the transformation's returned values, false otherwise
  Returns:
    a list of the argument definitions(`description`)) for the arguments that store the transformation's returned values if isReturnedValue is true, or a list of the argument definitions for the arguments that store the transformation's invoked arguments if isReturnedValue is false
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionIsReturnedValueList

    public static boolean[] getCompositeTransformationDefinitionIsReturnedValueList(int trans_id)
                                                                             throws TemplateTransformationRepositoryException,
                                                                                    RepositoryAccessException

  Returns a particular transformation's list of argument types (if they store a returned value or not). Returns `null` if no argument types exists for the specific transformation.

  Parameters:
    `trans_id` - ID of transformation
  Returns:
    a list of argument types (type is true if argument stores a returned value, false otherwise)
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionTableName

    public static java.lang.String getCompositeTransformationDefinitionTableName(int trans_id,
                                                                                 int arg_pos)
                                                                          throws TemplateTransformationRepositoryException,
                                                                                 RepositoryAccessException

  Returns a particular transformation's argument definition (only the `table_name` field).

  Parameters:
    `trans_id` - ID of transformation
    `arg_pos` - position in the transformation's sequence of arguments
  Returns:
    transformation's argument definition(`table_name`)
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` and `arg_pos`is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionFieldName

    public static java.lang.String getCompositeTransformationDefinitionFieldName(int trans_id,
                                                                                 int arg_pos)
                                                                          throws TemplateTransformationRepositoryException,
                                                                                 RepositoryAccessException

  Returns a particular transformation's argument definition (only the `field_name` field).

  Parameters:
    `trans_id` - ID of transformation
    `arg_pos` - position in the transformation's sequence of arguments
  Returns:
    transformation's argument definition(`field_name`)
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` and `arg_pos`is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionDescription

    public static java.lang.String getCompositeTransformationDefinitionDescription(int trans_id,
                                                                                   int arg_pos)
                                                                            throws TemplateTransformationRepositoryException,
                                                                                   RepositoryAccessException

  Returns a particular transformation's argument definition (only the `description` field).

  Parameters:
    `trans_id` - ID of transformation
    `arg_pos` - position in the transformation's sequence of arguments
  Returns:
    transformation's argument definition(`description`)
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` and `arg_pos`is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationDefinitionIsReturnedValue

    public static boolean getCompositeTransformationDefinitionIsReturnedValue(int trans_id,
                                                                              int arg_pos)
                                                                       throws TemplateTransformationRepositoryException,
                                                                              RepositoryAccessException

  Returns whether a particular transformation's argument stores a returned value after the transformation's invocation, or not.

  Parameters:
    `trans_id` - ID of transformation
    `arg_pos` - position in the transformation's sequence of arguments
  Returns:
    transformation argument's type (true if argument stores a returned value, false otherwise)
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` and `arg_pos`is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### setCompositeTransformationDefinitionTableName

    public static void setCompositeTransformationDefinitionTableName(int trans_id,
                                                                     int arg_pos,
                                                                     java.lang.String table_name)
                                                              throws TemplateTransformationRepositoryException,
                                                                     RepositoryAccessException

  Sets a particular transformation's argument definition (the `table_name` field).

  Parameters:
    `trans_id` - ID of composite transformation
    `arg_pos` - position in the transformation's sequence of arguments
    `table_name` - table name to be put in the specified position
  Throws:
    `TemplateTransformationRepositoryException` - if `table_name` is `null`, or if no record for the specified `trans_id` is found in the TTR's `comp_transformations` table, or if no record for the specified `trans_id` and `arg_pos`is found in the TTR's `comp_transformation_definition` table.
    `RepositoryAccessException` - if the repository cannot be accessed

### setCompositeTransformationDefinitionFieldName

    public static void setCompositeTransformationDefinitionFieldName(int trans_id,
                                                                     int arg_pos,
                                                                     java.lang.String field_name)
                                                              throws TemplateTransformationRepositoryException,
                                                                     RepositoryAccessException

  Sets a particular transformation's argument definition (the `field_name` field).

  Parameters:
    `trans_id` - ID of composite transformation
    `arg_pos` - position in the transformation's sequence of arguments
    `field_name` - field name to be put in the specified position
  Throws:
    `TemplateTransformationRepositoryException` - if `field_name` is `null`, or if no record for the specified `trans_id` is found in the TTR's `comp_transformations` table, or if no record for the specified `trans_id` and `arg_pos`is found in the TTR's `comp_transformation_definition` table.
    `RepositoryAccessException` - if the repository cannot be accessed

### setCompositeTransformationDefinitionDescription

    public static void setCompositeTransformationDefinitionDescription(int trans_id,
                                                                       int arg_pos,
                                                                       java.lang.String description)
                                                                throws TemplateTransformationRepositoryException,
                                                                       RepositoryAccessException

  Sets a particular transformation's argument definition (the `description` field).

  Parameters:
    `trans_id` - ID of composite transformation
    `arg_pos` - position in the transformation's sequence of arguments
    `description` - description to be put in the specified position
  Throws:
    `TemplateTransformationRepositoryException` - if `description` is `null`, or if no record for the specified `trans_id` is found in the TTR's `comp_transformations` table, or if no record for the specified `trans_id` and `arg_pos`is found in the TTR's `comp_transformation_definition` table.
    `RepositoryAccessException` - if the repository cannot be accessed

### setCompositeTransformationDefinitionIsReturnedValue

    public static void setCompositeTransformationDefinitionIsReturnedValue(int trans_id,
                                                                           int arg_pos,
                                                                           boolean isReturnedValue)
                                                                    throws TemplateTransformationRepositoryException,
                                                                           RepositoryAccessException

  Sets a particular transformation's argument type.

  Parameters:
    `trans_id` - ID of composite transformation
    `arg_pos` - position in the transformation's sequence of arguments
    `isReturnedValue` - true if the argument stores a returned value, false otherwise
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR's `comp_transformations` table, or if no record for the specified `trans_id` and `arg_pos`is found in the TTR's `comp_transformation_definition` table.
    `RepositoryAccessException` - if the repository cannot be accessed

### removeCompositeTransformationDefinition

    public static void removeCompositeTransformationDefinition(int trans_id,
                                                               int arg_pos)
                                                        throws TemplateTransformationRepositoryException,
                                                               RepositoryAccessException

  Removes a particular position of a transformation's sequence of arguments

  Parameters:
    `trans_id` - ID of transformation
    `arg_pos` - position in the transformation's sequence of arguments to be removed
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` and `arg_pos` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### removeCompositeTransformationDefinition

    public static void removeCompositeTransformationDefinition(int trans_id)
                                                        throws RepositoryAccessException

  Removes all arguments definitions of a particular composite transformation

  Parameters:
    `trans_id` - ID of transformation
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### createArgument

    public static void createArgument(int arg_id,
                                      int arg_pos,
                                      int arg_id_ref,
                                      int arg_pos_ref,
                                      java.lang.String value)
                               throws TemplateTransformationRepositoryException,
                                      RepositoryAccessException

  Adds a new argument to a sequence of arguments

  Parameters:
    `arg_id` - ID of sequence of arguments
    `arg_pos` - position of argument in the sequence of arguments
    `arg_id_ref` - and
    `arg_pos_ref` - refer to an argument in another sequence
    `value` - the value of the specific argument
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed
    `TemplateTransformationRepositoryException` - if the arguments are invalid ( `arg_id` less/equal to zero,`arg_pos` less/equal to zero, `arg_pos_ref` less/equal to zero and `value` equal to `null`).or if a record already exists for the specified `arg_id` and `arg_pos`. Note: `arg_id_ref` and `arg_pos_ref` have higher 'precedence' than `value`.

### createFirstArgument

    public static int createFirstArgument(int arg_pos,
                                          int arg_id_ref,
                                          int arg_pos_ref,
                                          java.lang.String value)
                                   throws TemplateTransformationRepositoryException,
                                          RepositoryAccessException

  Creates a new sequence of arguments and adds a new argument to the sequence

  Parameters:
    `arg_pos` - position of argument in the new sequence of arguments
    `arg_id_ref` - and
    `arg_pos_ref` - refer to an argument in another sequence
    `value` - the value of the specific argument
  Returns:
    ID of the new sequence of arguments
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed
    `TemplateTransformationRepositoryException` - if the arguments are invalid ( `arg_pos` less/equal to zero or `arg_pos_ref` less/equal to zero and `value` equal to `null`. Note: `arg_id_ref` and `arg_pos_ref` have higher 'precedence' than `value`.

### getArgumentsArgIdList

    public static int[] getArgumentsArgIdList()
                                       throws RepositoryAccessException

  Returns a list of identifiers of all the sequences of arguments

  Returns:
    a list of dentifiers of all the sequences of arguments
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### getArgumentsArgPosList

    public static int[] getArgumentsArgPosList(int arg_id)
                                        throws RepositoryAccessException

  Returns a particular's sequence of arguments list of positions. Returns `null` if a sequence of arguments with the specific ID doesn't exist.

  Parameters:
    `arg_id` - ID of sequence of arguments
  Returns:
    a list of positions in the sequence
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### getArgumentsArgIdRefList

    public static int[] getArgumentsArgIdRefList(int arg_id)
                                          throws RepositoryAccessException

  Returns a particular's sequence of arguments list of `arg_id_ref` fields. Returns `null` if a sequence of arguments with the specific ID doesn't exist.

  Parameters:
    `arg_id` - ID of sequence of arguments
  Returns:
    a list of `arg_id_ref` fields in the sequence
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### getArgumentsArgPosRefList

    public static int[] getArgumentsArgPosRefList(int arg_id)
                                           throws RepositoryAccessException

  Returns a particular's sequence of arguments list of `arg_pos_ref` fields. Returns `null` if a sequence of arguments with the specific ID doesn't exist.

  Parameters:
    `arg_id` - ID of sequence of arguments
  Returns:
    a list of `arg_pos_ref` fields in the sequence
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### getArgumentsValueList

    public static java.lang.String[] getArgumentsValueList(int arg_id)
                                                    throws RepositoryAccessException

  Returns a particular's sequence of arguments list of values. Returns `null` if a sequence of arguments with the specific ID doesn't exist.

  Parameters:
    `arg_id` - ID of sequence of arguments
  Returns:
    a list of values in the sequence
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### getArgumentsArgIdRef

    public static int getArgumentsArgIdRef(int arg_id,
                                           int arg_pos)
                                    throws TemplateTransformationRepositoryException,
                                           RepositoryAccessException

  Returns a particular argument's `arg_id_ref` field

  Parameters:
    `arg_id` - ID of sequence
    `arg_pos` - position in the specified sequence
  Returns:
    the `arg_id_ref` of the specified argument
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `arg_id` and `arg_pos` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getArgumentsArgPosRef

    public static int getArgumentsArgPosRef(int arg_id,
                                            int arg_pos)
                                     throws TemplateTransformationRepositoryException,
                                            RepositoryAccessException

  Returns a particular argument's `arg_pos_ref` field

  Parameters:
    `arg_id` - ID of sequence
    `arg_pos` - position in the specified sequence
  Returns:
    the `arg_pos_ref` of the specified argument
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `arg_id` and `arg_pos` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### getArgumentsValue

    public static java.lang.String getArgumentsValue(int arg_id,
                                                     int arg_pos)
                                              throws TemplateTransformationRepositoryException,
                                                     RepositoryAccessException

  Returns a particular argument's `value` field

  Parameters:
    `arg_id` - ID of sequence
    `arg_pos` - position in the specified sequence
  Returns:
    the `value` of the specified argument
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `arg_id` and `arg_pos` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### setArgumentsArgIdRef

    public static void setArgumentsArgIdRef(int arg_id,
                                            int arg_pos,
                                            int arg_id_ref)
                                     throws TemplateTransformationRepositoryException,
                                            RepositoryAccessException

  Sets an argument's `arg_id_ref` field

  Parameters:
    `arg_id` - ID of sequence
    `arg_pos` - position in the sequence of arguments
    `arg_id_ref` - arg_id_ref to be put in the specified position
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `arg_id` and `arg_pos` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### setArgumentsArgPosRef

    public static void setArgumentsArgPosRef(int arg_id,
                                             int arg_pos,
                                             int arg_pos_ref)
                                      throws TemplateTransformationRepositoryException,
                                             RepositoryAccessException

  Sets an argument's `arg_pos_ref` field

  Parameters:
    `arg_id` - ID of sequence
    `arg_pos` - position in the sequence of arguments
    `arg_pos_ref` - arg_pos_ref to be put in the specified position
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `arg_id` and `arg_pos` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### setArgumentsValue

    public static void setArgumentsValue(int arg_id,
                                         int arg_pos,
                                         java.lang.String value)
                                  throws TemplateTransformationRepositoryException,
                                         RepositoryAccessException

  Sets an argument's `value` field

  Parameters:
    `arg_id` - ID of sequence
    `arg_pos` - position in the sequence of arguments
    `value` - value to be put in the specified position
  Throws:
    `TemplateTransformationRepositoryException` - if value is `null`, or if no record for the specified `arg_id` and `arg_pos` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### removeArgument

    public static void removeArgument(int arg_id,
                                      int arg_pos)
                               throws TemplateTransformationRepositoryException,
                                      RepositoryAccessException

  Removes a particular position from a sequence of arguments

  Parameters:
    `arg_id` - ID of sequence
    `arg_pos` - position in the sequence of arguments to be removed
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `arg_id` and `arg_pos` is found in the TTR or if there is a dependency conflict (a statement using this `arg_id` in the `comp_tranformation_program` table, and this is the last position existing in the specific sequence of arguments)
    `RepositoryAccessException` - if the repository cannot be accessed

### removeArguments

    public static void removeArguments(int arg_id)
                                throws TemplateTransformationRepositoryException,
                                       RepositoryAccessException

  Removes a particular sequence of arguments

  Parameters:
    `arg_id` - ID of sequence to be removed
  Throws:
    `TemplateTransformationRepositoryException` - if there is a dependency conflict (a statement using this `arg_id` in the `comp_tranformation_program` table)
    `RepositoryAccessException` - if the repository cannot be accessed

### createCompositeTransformationProgram

    public static void createCompositeTransformationProgram(int trans_id,
                                                            int pc,
                                                            int st_id,
                                                            int arg_id)
                                                     throws TemplateTransformationRepositoryException,
                                                            RepositoryAccessException

  Adds a new statement to a composite transformation's program

  Parameters:
    `trans_id` - ID of transformation
    `pc` - program counter of statement to be added
    `st_id` - ID of statement to be added
    `arg_id` - ID of the statement's sequence of arguments (the argument is going to be executed with the specified arguments)
  Throws:
    `TemplateTransformationRepositoryException` - if the arguments are invalid ( `trans_id` or `pc` less/equal to zero), or if no record for the specified `arg_id` is found in the TTR's `arguments` table, or if no record for the specified `trans_id` is found in the TTR's `comp_transformations` table, or if the specified `st_id` isn't valid (hasn't been defined in TTSR, see `TemplateTransformationSyntaxRepository.isValidStId(int)`), or if a record already exists for the specified `trans_id` and `pc`
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationProgramPcList

    public static int[] getCompositeTransformationProgramPcList(int trans_id)
                                                         throws TemplateTransformationRepositoryException,
                                                                RepositoryAccessException

  Returns a list of program counters of a particular composite transformation's template program. Returns `null` if there isn't a template program for the specific transformation.

  Parameters:
    `trans_id` - ID of transformation
  Returns:
    a list of program counters of the transformation's template program
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR's `comp_transformations` table.
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationProgramStIdList

    public static int[] getCompositeTransformationProgramStIdList(int trans_id)
                                                           throws TemplateTransformationRepositoryException,
                                                                  RepositoryAccessException

  Returns a list of statement identifiers of a particular composite transformation's template program, ie the statements that are going to be executed at each program counter. Returns `null` if there isn't a template program for the specific transformation.

  Parameters:
    `trans_id` - ID of transformation
  Returns:
    a list of statement identifiers of the transformation's template program
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR's `comp_transformations` table.
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationProgramArgIdList

    public static int[] getCompositeTransformationProgramArgIdList(int trans_id)
                                                            throws TemplateTransformationRepositoryException,
                                                                   RepositoryAccessException

  Returns a list of sequence of arguments identifiers of a particular composite transformation's template program, ie the sequences of arguments that are going to be used at each program counter. Returns `null` if there isn't a template program for the specific transformation.

  Parameters:
    `trans_id` - ID of transformation
  Returns:
    a list of sequence of arguments identifiers of the transformation's template program
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR's `comp_transformations` table.
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationProgramStId

    public static int getCompositeTransformationProgramStId(int trans_id,
                                                            int pc)
                                                     throws TemplateTransformationRepositoryException,
                                                            RepositoryAccessException

  Returns the statement ID of the statement that is going to be executed at the specified pc of a transformation's template program.

  Parameters:
    `trans_id` - ID of transformation
  Returns:
    the statement identifier of the statement that is going to be executed at the specified program counter of the specified template program
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` and `pc` is found in the TTR's `comp_transformation_program` table.
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationProgramArgId

    public static int getCompositeTransformationProgramArgId(int trans_id,
                                                             int pc)
                                                      throws TemplateTransformationRepositoryException,
                                                             RepositoryAccessException

  Returns the sequence of arguments ID that is going to be used at the specified pc of a transformation's template program.

  Parameters:
    `trans_id` - ID of transformation
  Returns:
    the sequence of arguments ID that is going to be used at the specified program counter of the specified template program
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` and `pc` is found in the TTR's `comp_transformation_program` table.
    `RepositoryAccessException` - if the repository cannot be accessed

### setCompositeTransformationProgramStId

    public static void setCompositeTransformationProgramStId(int trans_id,
                                                             int pc,
                                                             int st_id)
                                                      throws TemplateTransformationRepositoryException,
                                                             RepositoryAccessException

  Sets the statement identifier in a specific program counter in the specified composite transformation's template program

  Parameters:
    `trans_id` - ID of composite transformation
    `pc` - program counter in the transformation's template program
    `st_id` - statement identifier to be put in the specified pc
  Throws:
    `TemplateTransformationRepositoryException` - if the specified `st_id` is not valid (see `TemplateTransformationSyntaxRepository.isValidStId(int)`), or if no record for the specified `trans_id` and `pc` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### setCompositeTransformationProgramArgId

    public static void setCompositeTransformationProgramArgId(int trans_id,
                                                              int pc,
                                                              int arg_id)
                                                       throws TemplateTransformationRepositoryException,
                                                              RepositoryAccessException

  Sets the sequence of arguments ID in a specific program counter in the composite transformation's template program

  Parameters:
    `trans_id` - ID of composite transformation
    `pc` - program counter in the template transformation's program
    `arg_id` - sequence of arguments identifier to be put in the specified pc
  Throws:
    `TemplateTransformationRepositoryException` - if no records for the specified `arg_id` exists in the TTR's `arguments` table, or if no record for the specified `trans_id` and `pc` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### removeCompositeTransformationProgram

    public static void removeCompositeTransformationProgram(int trans_id,
                                                            int pc)
                                                     throws TemplateTransformationRepositoryException,
                                                            RepositoryAccessException

  Removes a particular program counter of a transformation's template program

  Parameters:
    `trans_id` - ID of transformation
    `pc` - program counter in the transformation's program
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` and `pc` is found in the TTR
    `RepositoryAccessException` - if the repository cannot be accessed

### removeCompositeTransformationProgram

    public static void removeCompositeTransformationProgram(int trans_id)
                                                     throws RepositoryAccessException

  Removes a particular template transformation's program

  Parameters:
    `trans_id` - ID of transformation
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### createCompositeTransformationReturnedValuesDefinition

    public static void createCompositeTransformationReturnedValuesDefinition(int trans_id,
                                                                             int arg_id)
                                                                      throws TemplateTransformationRepositoryException,
                                                                             RepositoryAccessException

  Defines where the transformation's returned values are stored.

  Parameters:
    `trans_id` - ID of transformation
    `arg_id` - ID of the argument sequence where the returned values are defined
  Throws:
    `TemplateTransformationRepositoryException` - if the arguments are invalid ( `trans_id` or `pc` less/equal to zero), or if no record for the specified `arg_id` is found in the TTR's `arguments` table, or if no re cord for the specified `trans_id` is found in the TTR's `comp_transformations` table, or or if a record already exists for the specified `trans_id`
    `RepositoryAccessException` - if the repository cannot be accessed

### getCompositeTransformationReturnedValuesDefinitionArgId

    public static int getCompositeTransformationReturnedValuesDefinitionArgId(int trans_id)
                                                                       throws TemplateTransformationRepositoryException,
                                                                              RepositoryAccessException

  Returns the sequence of arguments ID that defines the returned values of the transformation

  Parameters:
    `trans_id` - ID of transformation
  Returns:
    the sequence of arguments ID that defines the returned values of the transformation
  Throws:
    `TemplateTransformationRepositoryException` - if no record for the specified `trans_id` is found in the TTR's `comp_transformation_returned_values_definition` table.
    `RepositoryAccessException` - if the repository cannot be accessed

### setCompositeTransformationReturnedValuesDefinitionArgId

    public static void setCompositeTransformationReturnedValuesDefinitionArgId(int trans_id,
                                                                               int arg_id)
                                                                        throws TemplateTransformationRepositoryException,
                                                                               RepositoryAccessException

  Sets the sequence of arguments ID that defines the transformation's returned values.

  Parameters:
    `trans_id` - ID of composite transformation
    `arg_id` - sequence of arguments ID defining the transformation's returned values
  Throws:
    `TemplateTransforamtionRepositoryException` - if no records for the specified `arg_id` exists in the TTR's `arguments` table, or if no record for the specified `trans_id` is found in the TTR's `comp_transformation_returned_values_definition`
    `RepositoryAccessException` - if the repository cannot be accessed
    `TemplateTransformationRepositoryException`

### removeCompositeTransformationReturnedValuesArgumentDefinition

    public static void removeCompositeTransformationReturnedValuesArgumentDefinition(int trans_id)
                                                                              throws RepositoryAccessException

  Removes a composite transformation returned values definition

  Parameters:
    `trans_id` - ID of transformation
  Throws:
    `RepositoryAccessException` - if the repository cannot be accessed

### main

    public static void main(java.lang.String[] args)

### getDataSourceName

    public static java.lang.String getDataSourceName()

  Returns the name of the repository in the local database.

  Returns:
    the name of the repository in the local database.

### setDataSourceName

    public static void setDataSourceName(java.lang.String str)

  Sets the name of the repository in the local database. This name is set to `TTR` by default.

  Parameters:
    `str` - the name of the repository in the local database.

Overview | Package | Class | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD